/* Rotary input Test
 
Reinhard Kopka 29.12.2018
  
*/

#include "rotary_input.h"

// Pins:
#define ROTARY1    2  // for init, pulse input
#define ROTARY2    3  // for init, pulse input
#define ROTARYKEY A2  // used in app, press button

// for application - not necessary, but useful
bool    pressed=false;
bool    position_change = false;

void setup() 
{
 
  //rotary_set(menu_used->min_val, menu_used->max_val, menu_used->start, 1, 1,0);   // to set the characteristic needed (example)
  //rotary_reset();   // not needed - will be done with rotary_set()
  rotary_init(ROTARY1, ROTARY2);

// nur Eingang 
  pinMode(ROTARYKEY, INPUT_PULLUP);

  Serial.begin(9600);
  pinMode(LED_BUILTIN, OUTPUT);
}
 
int i=0;
static bool ispressed=false;
  
void loop() 
{   
  // Wert wird außerhalb geändert, hier wird nur eine Änderung detektiert
  position_change=rotary_haschanged();

  // keine Variable nötig, aber evt. kommt noch eine Entprellung
  if (!digitalRead(ROTARYKEY))  pressed=true;  
  else                          pressed=false;
    
 Serial.print("Encoder: ");
 Serial.print(encoderPos);
 Serial.print("  Val:");
 Serial.print(encoderPosVal);
 Serial.print("   ");
 Serial.print(digitalRead(ROTARY1));
 Serial.print(" , ");
 Serial.print(digitalRead(ROTARY2));
 Serial.print(" ; pressed: ");
 Serial.print(pressed);
 Serial.print(" mode: ");
 Serial.print(i);
 
 Serial.println("   ");

  // test different counter setups
 if (pressed)
 {
    if (!ispressed)
    {
      i++;
      if (i==1)
        //set_rotary(int16_t min, int16_t max, int16_t start, int16_t step, int16_t factor, uint8_t flag)  
        rotary_set(-10, 10, -1, 1, 2, 1);
      else if (i==2)
        rotary_set(11, 31, 20,2, 1, 2);
      else if (i==3)
        rotary_set(0, 10, 5,1, 1, 3);  
      else 
      {
        i=0;
        rotary_set(0, 255, 0, 1, 2, 0);
        //r_min=0, r_max=255, r_start=0, r_step=1, r_factor=2, r_flag=0;
      }
    }
    ispressed=true;    
    digitalWrite(LED_BUILTIN, HIGH);
 }
 else 
 {
    ispressed=false;
    digitalWrite(LED_BUILTIN, LOW);
 }
 
}

